openapi: 3.0.0
info:
  version: 1.0.0
  title: Cloud snack API
  description: The always-on component of the FMF snack-buying system

paths:
  /transactions:
    post:
      description: Push one or many transactions, which might've been accumulated over a longer period of the machine being offline
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: array
              items:
                type: object
                title: Transaction
                required: [ userId, time, products ]
                properties:
                  userId:
                    type: integer
                  time:
                    description: Unix timestamp
                    type: integer
                  products:
                    type: array
                    items:
                      type: object
                      title: TransactionProduct
                      required: [ id, unitPrice, quantity ]
                      properties:
                        id:
                          type: integer
                        unitPrice:
                          type: integer
                        quantity:
                          type: integer
      responses:
        '200':
          description: Successfully pushed transactions

  /products:
    get:
      description: Get a complete list of products and their barcodes
      responses:
        '200':
          description: Successfully returned the list of products
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  title: Product
                  required: [ id, name, price, barcode ]
                  properties:
                    id:
                      type: integer
                    name:
                      type: string
                    price:
                      type: integer
                    barcode:
                      type: string
  /users:
    get:
      description: Get a complete list of user-nfc pairs
      responses:
        '200':
          description: Successfully returned the list of users
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  title: User
                  required: [ id, name, cards ]
                  properties:
                    id:
                      type: integer
                    name:
                      type: string
                    cards:
                      type: array
                      items:
                        title: Card
                        type: object
                        required: [ id, hex ]
                        properties:
                          id:
                            type: integer
                          hex:
                            type: string

  /cards:
    post:
      description: Register a new card
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              title: Card
              required: [ hex ]
              properties:
                hex:
                  type: string

      responses:
        '200':
          description: Successfully registered card
